(function() {

    if (window.HDH) {
        return;
    }

    var messageHandlers = {};
    var uniqueId = 1;

    function registerCallback(name, callback, scope = window) {
        var fnName = name + '_' + uniqueId++ + '_' + new Date().getTime()
        window[fnName] = function() {
            unregisterCallback(fnName)
            callback.apply(scope, arguments)
        }
        return fnName
    }

    function unregisterCallback(name) {
        delete window[name]
    }

    //调用
    function sendToNative(methodName, params,  callback) {
        if(window.ecloud) {
            params = params || "{}";
            if (callback) {
                var callbackId = registerCallback(methodName, callback);
                window.ecloud.messageSend(methodName, callbackId, JSON.stringify(params));
            } else {
                return window.ecloud.syndMessageSend(methodName, JSON.stringify(params))
            }
        }
        return null;
    }

    //异步回调
    function callBackFromNative(callbackId, type, params) {
        if (callbackId) {
            var callback = messageHandlers[callbackId];
            delete messageHandlers[callbackId];
            if (callback) {
                var dict = null;
                if(params && params != 'null') {
                    dict = JSON.parse(params);
                }
                callback(dict);
            }
        };
    }

    window.HDH = {
        sendToNative 			: sendToNative,
        callBackFromNative		: callBackFromNative
    };

})();